=== src/qdoc/qdoc/tests/CMakeLists.txt ===
add_subdirectory(qdoc)
add_subdirectory(config)
add_subdirectory(qdoccommandlineparser)
add_subdirectory(utilities)
add_subdirectory(generatedoutput)
add_subdirectory(validateqdocoutputfiles)
